<template>
  <div>
    <div :class="color">
          <st-subtitle text="Resultados de la sesión"/>
      <v-row no-gutters>
        <v-col>
          <v-row>
            <v-col align-self="center" md="6">
              <v-label>Comentarios:</v-label>
            </v-col>
            <v-col align-self="center" md="2">
              <v-label>Derivación:</v-label>
            </v-col>
            <v-col align-self="center" md="4">
              <v-select :readonly="!historical" :items="estados" v-model="derivacion" :value="valueDer" item-text="telefono" item-value="idUnidadSoporte" />
            </v-col>
          </v-row>
          <v-row>
            <v-col md="12">
              <v-textarea :readonly = "!historical" :auto-grow="true" :rows="1" v-model="comentario" :value ="valueCom"></v-textarea>
            </v-col>
          </v-row>
          <v-row>
            <v-col align-self="center" md="6">
              <v-label>Plan de acción:</v-label>
            </v-col>
            <v-col align-self="center" md="2">
              <v-label>Seguimiento:</v-label>
            </v-col>
            <v-col align-self="center" md="4">
              <v-switch inset v-model="seguimiento" readonly></v-switch>
            </v-col>
          </v-row>
          <v-row>
            <v-col md="6">
              <v-list :class="color">
                <st-subtitle :text="planDeAccion.length + text" />
                <v-flex xs12>
                  <v-text-field
                    v-if = historical
                    clearable
                    v-model="newTodo"
                    id="newTodo"
                    name="newTodo"
                    label="Ingrese el plan de acción"
                    @keyup.enter="addTodo"
                  ></v-text-field>
                </v-flex>
                <div v-for="(todo, i) in planDeAccion" :key="i">
                  <v-list-item>
                    <v-list-item-action>
                      <v-checkbox :readonly="!historical" v-model="todo.completado" @change="check"></v-checkbox>
                    </v-list-item-action>
                    <v-list-item-content>
                      <v-list-item-title
                        :class="{done: todo.completado}"
                      >{{todo.nombre | capitalize}}</v-list-item-title>
                    </v-list-item-content>
                    <v-btn
                      icon
                      ripple
                      color="secondary"
                      
                      @click="removeTodo(i)"
                    >
                      <i class="fas fa-times"></i>
                    </v-btn>
                  </v-list-item>
                </div>
              </v-list>
            </v-col>
          </v-row>
        </v-col>
      </v-row>
    </div>
  </div>
</template>

<script>
import Select from "@/components/Select";
export default {
    props:{
        valueCom: String,
        planDeAccion: Array,
        valueDer : String,
        color: String,
        historical : Boolean,
    },
  data() {
    return {
      estados: [],
      comentario: null,
      derivacion: this.valueDer,
      seguimiento: false,
      text: " tarea(s) pendiente(s)",
      newTodo: ""
    };
  },
  components: {
    "st-select": Select
  },
  methods: {
    async ini() {
        this.check();
        try {
         //   let data = []
             let { data: { data } } = await this.$api.getSupportUnits()
            this.estados = data
        } catch (e) {
            this.$store.commit('setError', e)
        }
    },
    addTodo() {
      var value = this.newTodo && this.newTodo.trim();
      if (!value) {
        return;
      }
      this.planDeAccion.push({
        nombre: this.newTodo,
       completado: false
      });
      this.newTodo = "";
      this.check();
    },
    removeTodo(index) {
       this.planDeAccion.splice(index, 1);
      this.check();
    },
    check() {
      let cant = 0;
      let total = 0;
       for (let todo in this.planDeAccion){
        if(this.planDeAccion[todo].completado === true) cant++;
        total++;
      }
      if(cant == total) this.seguimiento = false;
      else this.seguimiento = true;
    },
    imprimir(){
        let data = {
            comentario : this.comentario,
            derivacion : this.derivacion,
            planDeAccion : this.planDeAccion,
            seguimiento : this.seguimiento,
        }
        return data
    },
    
  },
  mounted() {
    this.ini();
  },
  updated(){
     if(!this.comentario){
       this.comentario = this.valueCom
     } 
     if(!this.derivacion){     
       this.derivacion = this.valueDer
     }
    this.check();
  },
  filters: {
    capitalize: function(value) {
      if (!value) return "";
      value = value.toString();
      return value.charAt(0).toUpperCase() + value.slice(1);
    }
  }
};
</script>
<style scoped lang="scss">
.font-regular {
  margin-left: auto;
  margin-right: auto;
  font-size: 12px;
  text-transform: uppercase;
  text-align: center;
}
.content-body2{
    margin-top:20px;
    padding:20px;
    background:#f2f2f28a;
    border-radius:10px;
}

</style>